/* Copyright (C) 1995-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Ulrich Drepper, <drepper@gnu.ai.mit.edu>

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */

#include <wchar.h>

#ifndef WCSRCHR
# define WCSRCHR wcsrchr
#endif

/* Find the last occurrence of WC in WCS.  */
wchar_t *
WCSRCHR (const wchar_t *wcs, const wchar_t wc)
{
  const wchar_t *retval = NULL;

  do
    if (*wcs == wc)
      retval = wcs;
  while (*wcs++ != L'\0');

  return (wchar_t *) retval;
}
